/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * MemoryGrapherForm.java
 *
 * Created on May 25, 2009, 6:16:17 PM
 */
package org.jboss.webbeans.environment.se.example.simple;

import java.awt.Dimension;
import java.io.Serializable;
import javax.event.Observes;
import javax.inject.Current;
import javax.inject.Initializer;
import javax.inject.manager.Deployed;
import javax.inject.manager.Manager;
import org.jboss.webbeans.environment.se.ShutdownManager;
import org.jboss.webbeans.log.Log;
import org.jboss.webbeans.log.Logger;
import org.jfree.chart.ChartFactory;
import org.jfree.chart.ChartPanel;
import org.jfree.chart.JFreeChart;
import org.jfree.chart.plot.PlotOrientation;
import org.jfree.data.category.CategoryDataset;

/**
 *
 * @author Pete Royle
 */
public class MemoryGrapherForm extends javax.swing.JFrame implements Serializable
{

    @Current CategoryDataset catDataSet;

    @Current ShutdownManager shutdownManager;
    @Current Manager manager;

    @Logger Log log;

    /** Creates new form MemoryGrapherForm */
    public MemoryGrapherForm()
    {
        super("WebBeans SE Graph Example");
        initComponents();
        setSize(new Dimension(800, 600));

    }

    @Initializer
    public void initChart()
    {
        log.info("Initializing");
        JFreeChart chart = ChartFactory.createLineChart3D(
                "Free Memory", "Time", "Bytes", catDataSet, PlotOrientation.VERTICAL, true, true, true);
        ChartPanel chartPanel = new ChartPanel(chart);
        setContentPane(chartPanel);
    }

    /**
     * @param args the command line arguments
     */
    public void main(@Observes @Deployed Manager manager)
    {
        log.info("Running");
        java.awt.EventQueue.invokeLater(new Runnable()
        {
            public void run()
            {
                setVisible(true);
            }
        });
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosed(java.awt.event.WindowEvent evt) {
                formWindowClosed(evt);
            }
        });

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void formWindowClosed(java.awt.event.WindowEvent evt)//GEN-FIRST:event_formWindowClosed
    {//GEN-HEADEREND:event_formWindowClosed
        shutdownManager.shutdown(manager);
    }//GEN-LAST:event_formWindowClosed

    // Variables declaration - do not modify//GEN-BEGIN:variables
    // End of variables declaration//GEN-END:variables
}
